<?php
/** 
 * Hot Price Module v0.8
 * Developed by Rod_ - 2009
**/

class HotPrice extends Module
{
    private $_html = '';
    private $_postErrors = array();

    function __construct()
    {
        $this->name = 'hotprice';
        $this->tab = 'Blocks';
        $this->version = 0.8;

        parent::__construct();

        /* The parent construct is required for translations */
		$this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('Special Countdown');
        $this->description = $this->l('Adds a hot price product countdown timer');
    }

    function install()
    {
        parent::install();
        $this->registerHook('rightColumn');
    }

    function hookRightColumn($params)
    {
		global $smarty;
		global $product_idx;

		if ($special = Product::getRandomSpecial(intval($params['cookie']->id_lang))) {
			$product_idx = $special['id_product'];
			$smarty->assign(array(
			'special' => $special,
			'oldPrice' => number_format($special['price'] + $special['reduction'], 2, '.', '')
));}

		#print_r($product_idx);

		//******************************** START *********************************************
		//
		// MICRO COUNTDOWN  -  Version: 1.0
		//
		//*****************************************************************************
		
		// SQL QUERY
		
		/** 
		 * IMPORTANT: 
		 * PROBABLY YOU WILL NEED TO CHANGE THE DB PREFIX (`ps_product`).
		 * NOTES:
		 * CHANGE THE REDUCTION PRICE OR PERCENT FOR PERSONALISED SPECIALS 
		 * (Example: reduction_percent` >= '20'). This will activate the module only for discounts over 20% off.
		 **/
		 
		$currentDate = date('Y-m-d');
		
		$result = db::getInstance()->ExecuteS("SELECT * FROM `ps_product`
													WHERE `id_product` = '".$product_idx."' 
													  AND `reduction_to` > '".$currentDate."'
													  AND (`reduction_price` > '0' OR `reduction_percent` > '0')
													LIMIT 0,1");
		
		if ($result[0] == "")
		{
			$superman = 1;
			$smarty->assign('superman', $superman);
		}
		else
		{
			$superman = 0;
			$smarty->assign('superman', $superman);
			
			foreach ($result as $row) 
			{
   				$date_f = $row['reduction_to'];
			}
		}
		
		// String extraction
		$year_f = substr($date_f,0,4);
		$month_f = substr($date_f,5,2);
		$day_f = substr($date_f,8,2);

		// Define your target date here
		$targetYear  = $year_f;
		$targetMonth = $month_f;
		$targetDay   = $day_f;
		$targetHour  = 23;
		$targetMinute= 59;
		$targetSecond= 59;
	
		// Define date format
		$dateFormat = "Y-m-d H:i:s";
	
		$targetDate = mktime($targetHour,$targetMinute,$targetSecond,$targetMonth,$targetDay,$targetYear);
		$actualDate = time();
	
		$secondsDiff = $targetDate - $actualDate;
		
		// Avoid wrong timer on 00:00 hours
		if ($secondsDiff < 0)
		{
			$centinel = 1;
			$smarty->assign('centinel', $centinel);
		}
	
		$remainingDay = floor($secondsDiff/60/60/24);
		
		// More than 1 day discount
		if ($remainingDay > 0)
		{
			$wolverine = 1;
			$smarty->assign('wolverine', $wolverine);
		}
		
		$remainingHour = floor(($secondsDiff-($remainingDay*60*60*24))/60/60);
		$remainingMinutes = floor(($secondsDiff-($remainingDay*60*60*24)-($remainingHour*60*60))/60);
		$remainingSeconds = floor(($secondsDiff-($remainingDay*60*60*24)-($remainingHour*60*60))-($remainingMinutes*60));
	
		#$targetDateDisplay = date($dateFormat,$targetDate);
		#$actualDateDisplay = date($dateFormat,$actualDate);

		// Smarty Assigns:
		$smarty->assign('remainingDay', $remainingDay);
		$smarty->assign('remainingHour', $remainingHour);
		$smarty->assign('remainingMinutes', $remainingMinutes);
		$smarty->assign('remainingSeconds', $remainingSeconds);
		
		#$smarty->assign('targetDateDisplay', $targetDateDisplay);
		#$smarty->assign('actualDateDisplay', $actualDateDisplay);		

		# Debug
		#print_r($superman); // 0=Content Exists / 1=No Content
		#print("<br>");
		#print_r($todayX);

		return $this->display(__FILE__, 'hotprice.tpl');
	}
	
	function hookLeftColumn($params)
	{
		return $this->hookRightColumn($params);
	}
}

?>